apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ wekan_name }}
  name: {{ wekan_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ wekan_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ wekan_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ wekan_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ wekan_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ wekan_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ wekan_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: CUSTOM_LOGO
          value: logo-{{ wekan_theme }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if do_ldap %}
        - name: LDAP_AUTHENTIFICATION_PASSWORD
          valueFrom:
            secretKeyRef:
              key: wekan-password
              name: {{ ldap_secret_name }}
        - name: LDAP_BASEDN
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: LDAP_BIND_PREFIX
          value: cn=wekan,ou=services
        - name: LDAP_DEFAULT_DOMAIN
          value: {{ root_domain }}
        - name: LDAP_GROUP_FILTER_OBJECTCLASS
{% if do_fusion %}
          value: gosaGroupOfNames
{% else %}
          value: {{ wekan_ldap_group_objectclass }}
{% endif %}
        - name: LDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
{% endif %}
        - name: LDAP_INTERNAL_LOG_LEVEL
          value: "{% if do_debugs %}debug{% endif %}"
        - name: LDAP_LOG_ENABLED
          value: "true"
        - name: LDAP_PORT
{% if ldaps_address | default(False) %}
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: LDAP_PROTO
          value: ldaps
        - name: LDAP_REJECT_UNAUTHORIZED
{% if skip_ldap_verify | default(False) %}
          value: "false"
{% else %}
          value: ""
{% endif %}
{% else %}
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: LDAP_PROTO
          value: ldap
{% endif %}
        - name: LDAP_UNIQUE_IDENTIFIER_FIELD
          value: uid
        - name: LDAP_USER_SEARCH_FILTER
{% if do_fusion %}
          value: "(&(objectClass=gosaAccount)(!(pwdAccountLockedTime=*)))"
{% else %}
          value: "(&(objectClass={{ wekan_ldap_user_objectclass }})(!(pwdAccountLockedTime=*)))"
{% endif %}
{% endif %}
        - name: LEMON_PROTO
{% if do_lemon %}
          value: {{ lemon_portal | urlsplit('scheme') }}
{% else %}
          value: ""
{% endif %}
        - name: MAIL_FROM
          value: "Wekan <wekan@{{ root_domain }}>"
        - name: MAIL_URL
{% if smtp_relay | default(False) %}
{% if smtp_port | default(25) | int == 25 %}
          value: "smtp://{{ smtp_relay }}"
{% else %}
          value: "smtps://{{ smtp_relay }}:{{ smtp_port }}"
{% endif %}
{% elif smtp_address | default(False) %}
          value: {{ smtp_address }}
{% else %}
          value: ""
{% endif %}
        - name: MONGODB_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ wknmg_name }}
        - name: MONGODB_HOST
          value: {{ wknmg_name }}
        - name: MONGODB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ wknmg_name }}
        - name: MONGODB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ wknmg_name }}
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: "{% if ldaps_address | default(False) and skip_ldap_verify | default(False) %}0{% endif %}"
        - name: OAUTH2_CA_CERT
{% if do_lemon %}
{% if k8s_flavor != 'openshift' and tls_provider == 'internalca' %}
          value: /certs/ca.crt
{% else %}
          value: ""
{% endif %}
        - name: OAUTH2_EMAIL_MAP
          value: email
        - name: OAUTH2_FULLNAME_MAP
          value: name
        - name: OAUTH2_ID_MAP
          value: sub
        - name: OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: wekan-oauth2-secret
              name: {{ ldap_secret_name }}
        - name: OAUTH2_USERNAME_MAP
          value: name
{% else %}
          value: ""
        - name: OAUTH2_EMAIL_MAP
          value: ""
        - name: OAUTH2_FULLNAME_MAP
          value: ""
        - name: OAUTH2_ID_MAP
          value: ""
        - name: OAUTH2_SECRET
          value: ""
        - name: OAUTH2_USERNAME_MAP
          value: ""
{% endif %}
        - name: PASSWORD_LOGIN_ENABLED
          value: "{{ 'fals' if (do_lemon or do_ldap) else 'tru' }}e"
        - name: ROOT_URL
          value: https://{{ wekan_fqdn }}/
        - name: TZ
          value: {{ timezone }}
        - name: WITH_API
          value: "true"
{% if do_triggers == False or (opsimages | json_query("[?name=='wekan'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='wekan'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 20
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 60
          periodSeconds: 20
          tcpSocket:
            port: 8080
          timeoutSeconds: 3
        name: wekan
        ports:
        - containerPort: 8080
        readinessProbe:
          failureThreshold: 5
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 8080
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ wekan_cpu_limit }}"
            memory: "{{ wekan_memory_limit }}"
          requests:
            cpu: "{{ wekan_cpu_request }}"
            memory: "{{ wekan_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 20
          initialDelaySeconds: 60
          periodSeconds: 25
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /run
          name: tmp
          subPath: run
        - mountPath: /data
          name: tmp
          subPath: data
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ wekan_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
      - emptyDir: {}
        name: tmp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='wekan'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - wekan
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='wekan'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
